//+------------------------------------------------------------------+
//|                                                 ExtremeScalper EA|
//|                           Copyright  2007, Done by investor_me. |
//|                                            investor.me@gmail.com |
//+------------------------------------------------------------------+
#property copyright "By investor_me - All rights reserved"
#property link      "investor.me@gmail.com"

extern int x=8;
extern int y=5;
extern int MAGIC=000;

extern int timeframe=0;

extern int EMA=40;

extern int loss_limit=1460;

extern double Lots=0.1;
extern bool MM=true;
extern double MaxRisk=50;
extern bool use_starting_balance_ratio=false;
extern bool anti_martingale=true;
extern int anti_martingale_level=50;
extern bool choppy_market_filter=true;

extern int recovery_key=1;
extern bool randomize_recovery=false;
extern int recovery_steps=1;

extern int initial_takeprofit=5;
extern int minimum_takeprofit_allowed=10;
extern int initial_stoploss=60;
extern int minimum_stoploss=20;
extern int TP_increments=0;
extern int timeout=0;

int maximum_stoploss=1000;

int MaxLongTrades=1;
int MaxShortTrades=1;

extern int Trade_only_after=0;
extern int Trade_only_before=24;

extern bool ForceClose=true;

extern bool active_long=true;
extern bool active_short=true;

int MaxLots=900,original_balance,spread;

int i,current_trend_b,current_trend_s,buy_trend,sell_trend, buys, sells,last_day=-1,last_minute=-1,last_hour=-1,confirmed_buy_signals,confirmed_sell_signals,MMcount,confirm,confirm_sl,confirm_tp,last_order,closed,wins_count;

double   total_sell_length,total_buy_length,last_profit, last_lots,last_balance,MaxRiskPerTrade_percentage,last_wins; 

double   last_MA,C,max=-99999,sl,tp;

double 
       SL_b[20000],SL_s[20000],TP_b[20000],TP_s[20000],buy_price[20000][3],sell_price[20000][3],Buy_EMA[20000][11],Sell_EMA[20000][11],trends_b[20000][9],trends_s[20000][9], sell_time[20000],buy_time[20000];

int   Buy_table[20000][7],Sell_table[20000][7],Buy_date[20000][4],Sell_date[20000][4],count,target,start_recovery,partitions,
      total_buys[20000],total_sells[20000],Buy_confirmed[20000],Sell_confirmed[20000],lastwins_b[20000],lastwins_s[20000],successive_wins,factor_count,last_buy_time,last_sell_time;

datetime last_time, warning_time;

bool first_time=true,reported=false,r=false,conditioned=false,buy_now=false, sell_now=false;
  
/*******************************************************************************************************************/

int init()  
  { 
   last_lots=Lots;
   last_MA=0;
   original_balance=AccountBalance();
   if (initial_takeprofit==0) initial_takeprofit=5;
   sl=initial_stoploss; tp=initial_takeprofit;
   spread=MathRound((Ask-Bid)/Point);
   warning_time=TimeCurrent();
   MaxRiskPerTrade_percentage=MaxRisk;
   minimum_stoploss=initial_stoploss;
   return(0);
  }

int deinit(){ return(0); }
  
/*******************************************************************************************************************/

double M(int value, int level, int shift) 
   { 
      return (iMA(Symbol(),level,value,0,MODE_EMA,PRICE_CLOSE,shift));
   }
  
/*******************************************************************************************************************/

void clear_last_record(int type,int i)
 { int j;
   if (type==1)
      {
       for (j=0; j<3; j++)buy_price[i][j]=0;
       for (j=0; j<4; j++) Buy_date[i][j]=0;
       for (j=0; j<11; j++) Buy_table[i][j]=0;
       for (j=0; j<11; j++) Buy_EMA[i][j]=0;
       for (j=0; j<9; j++) trends_b[i][j]=0;
         total_buys[i]=0;  
         current_trend_b=0; 
      }
   else if (type==2)
      {
       for (j=0; j<4; j++) Sell_date[i][j]=0; 
       for (j=0; j<11; j++) Sell_table[i][j]=0; 
       for (j=0; j<11; j++) Sell_EMA[i][j]=0;
       for (j=0; j<9; j++)  trends_s[i][j]=0;
         total_sells[i]=0;  
         current_trend_s=0; 
      }
 }
  
/*******************************************************************************************************************/
void follow_buy_signal()
 {
    total_buys[buys]++;  
    if (total_buys[buys]==1)
       {
                        buy_price[buys][0]=C; 
                        Buy_table[buys][1]=Hour();
                        Buy_table[buys][2]=Minute();
                        current_trend_b=1; 
       }   
 }
/*******************************************************************************************************************/
bool condition2(int type)
   {   
   if (type==1 && (M(EMA,1,1)-M(EMA,1,0))/Point>y) { Print ("returned false b"); return (false); }
   if (type==2 && (M(EMA,1,0)-M(EMA,1,1))/Point>y) { Print ("returned false s");  return (false); }
   
return (true);
   }
/*******************************************************************************************************************/

void confirm_buy(int confirmed)
   {  double L;
               SL_b[buys]=Bid-Point*(sl);
               TP_b[buys]=Bid+Point*(tp);
               buy_price[buys][1]=C; 
               lastwins_b[buys]=confirmed_buy_signals;
               confirmed_sell_signals=0;

Buy_confirmed[buys]=1;
      if (confirmed==1 && ((OpenOrders(1)<MaxLongTrades && active_long) ||!active_long)
                         && Hour()>=Trade_only_after && Hour()<=Trade_only_before 
                       )
          {
              if (active_long && condition2(1)) OpenOrder(1);
               Buy_confirmed[buys]=1;
          }
   }
  
/*******************************************************************************************************************/

void end_buy(int confirmation)
{ 
   if (buy_price[buys][1]==0 && confirmation==0) 
      {  
         clear_last_record(1,buys); return; 
      }

   if (confirmation==1) confirmed_buy_signals++;
   else if (confirmation==0) confirmed_buy_signals=0;

   lastwins_b[buys]=confirmed_buy_signals;
   buy_price[buys][2]=C; 
   current_trend_b=0;  
   if (active_long && Buy_confirmed[buys]==1 && ForceClose && OpenOrders(1)) CloseOrder(1);

   buys++;
 }
  
/*******************************************************************************************************************/

void follow_sell_signal()
   {
    total_sells[sells]++;  
    if (total_sells[sells]==1 && sell_price[sells][0]==0)
       {
         sell_price[sells][0]=C;  
         Sell_table[sells][1]=Hour();
         Sell_table[sells][2]=Minute();
         current_trend_s=1; 
      }
   } 


void confirm_sell(int confirmed)
       { 
         double H;
                  SL_s[sells]=Ask+Point*(sl);
                  TP_s[sells]=Ask-Point*(tp);
                  sell_price[sells][1]=C; 
                  lastwins_s[sells]=confirmed_sell_signals;
                  confirmed_buy_signals=0;

              Sell_confirmed[sells]=1;

        if (confirmed==1 && ((OpenOrders(2)<MaxShortTrades && active_short) || !active_short)
                         && Hour()>=Trade_only_after && Hour()<=Trade_only_before 
                         )
              {
               if (active_short && condition2(2)) OpenOrder(2); 
               Sell_confirmed[sells]=1;
              } 
  } 
  
/*******************************************************************************************************************/

void end_sell(int confirmation)
  { 
   if (sell_price[sells][1]==0 && confirmation==0) 
      {  
         clear_last_record(2,sells); return; 
      }

   if (confirmation>0) confirmed_sell_signals++;
   else if (confirmation==0) confirmed_sell_signals=0;

   lastwins_s[sells]=confirmed_sell_signals;
   sell_price[sells][2]=C;
   current_trend_s=0;  
   if (active_short && Sell_confirmed[sells]==1 && ForceClose && OpenOrders(2)) CloseOrder(2);
 
   sells++;
 }    
/*******************************************************************************************************************/
void exit_check(int type)
  {
     if (type==1)
       {
         if (buy_price[buys][1]>0 && Buy_confirmed[buys]==1)
            {
              if (TP_b[buys]>0 && C>=TP_b[buys]) end_buy(1);
              if (SL_b[buys]>0 && C<=SL_b[buys]) end_buy(0);

              if (active_long && OpenOrders(1)==0) end_buy(0);
              
              if (choppy_market_filter)
                {
                      if (OpenOrders(1) && M(EMA,timeframe,0)<M(EMA,timeframe,x) && TimeCurrent()-last_buy_time>=timeout*60)  { count=count+MathCeil(x*(M(EMA,1,1)-M(EMA,1,0)/*+buy_price[buys][1]-P*/)/Point); } //MathCeil((M(EMA,1,x)-M(EMA,1,0))/Point)*MathCeil((M(EMA,1,x)-M(EMA,1,0))/Point); } //Print ("count:",count," diff:", (M(EMA,1,5)-M(EMA,1,0))/Point); } 
                      else count=0;

                      if (OpenOrders(1) && count>loss_limit)  { end_buy(0); CloseOrder(1);  buy_now=false; sell_now=true; closed++; Print (" reverse close b"); }//Print ("closed so far:",closed); } 
                }
            }
       }
     if (type==2)
       {
         if (Sell_confirmed[sells]==1 && sell_price[sells][1]>0)
            {
              if (TP_s[sells]>0 && C+Point*spread<=TP_s[sells])  end_sell(1);
              if (SL_s[sells]>0 && C>=SL_s[sells]) end_sell(0);
              if (active_short && OpenOrders(2)==0) end_sell(0);

               if (choppy_market_filter)
                {
                      if (OpenOrders(2) && M(EMA,timeframe,0)>M(EMA,timeframe,x) && TimeCurrent()-last_sell_time>=timeout*60) { count=count+MathCeil(x*(M(EMA,1,0)-M(EMA,1,1)/*+P-sell_price[sells][1]*/)/Point); }//MathCeil((M(EMA,1,0)-M(EMA,1,x))/Point)*MathCeil((M(EMA,1,0)-M(EMA,1,x))/Point); } //Print ("count:",count," diff:", (M(EMA,1,0)-M(EMA,1,5))/Point); } 
                      else count=0;
                      if (OpenOrders(2) && count>loss_limit)  { end_sell(0); CloseOrder(2); buy_now=true; sell_now=false; closed++;  Print (" reverse close s"); }//Print ("closed so far:",closed); } 
                }
            }    
        }
   }
/*******************************************************************************************************************/

void start_process()
  {
   if (active_long && !sell_now)
        {
          follow_buy_signal();

         if (0<last_MA && buy_price[buys][0]>0 && buy_price[buys][1]==0) end_buy(0);

         if (Buy_confirmed[buys]==0 && buy_price[buys][0]>0 && (total_buys[buys]>=0 || confirmed_buy_signals>0))
            {     
              if (buy_price[buys][1]==0 && total_buys[buys]>=0 && confirmed_buy_signals<confirm) confirm_buy(0);
              if (buy_price[buys][1]>0 && buy_price[buys][1]-C>=(confirm_sl)*Point && confirmed_buy_signals<confirm) end_buy(0);
              if (buy_price[buys][1]>0 && C-buy_price[buys][1]>=(confirm_tp)*Point && confirmed_buy_signals<confirm) end_buy(1);
            }

         if (buy_price[buys][0]>0 && buy_price[buys][1]==0 && confirmed_buy_signals>=confirm && total_buys[buys]>=0 && (OpenOrders(2)<MaxShortTrades && OpenOrders(1)<MaxLongTrades))
            confirm_buy(1);

         exit_check(1);
     }

   if (active_short && !buy_now)
     {
          follow_sell_signal();
         if (last_MA<0 && sell_price[sells][0]>0 && sell_price[sells][1]==0) end_sell(0);

         if ( sell_price[sells][0]>0 && Sell_confirmed[sells]==0 && (total_sells[sells]>=0 || confirmed_sell_signals>0))
            {     
              if (sell_price[sells][1]==0 && total_sells[sells]>=0 && confirmed_sell_signals<confirm) confirm_sell(0);
              if (sell_price[sells][1]>0 && C-sell_price[sells][1]>=(confirm_sl)*Point && confirmed_sell_signals<confirm) end_sell(0);
              if (sell_price[sells][1]>0 && sell_price[sells][1]-C>=(confirm_tp)*Point && confirmed_sell_signals<confirm) end_sell(1); 
            }
         if (sell_price[sells][0]>0 && sell_price[sells][1]==0 && confirmed_sell_signals>=confirm && total_sells[sells]>=0 && (OpenOrders(2)<MaxShortTrades && OpenOrders(1)<MaxLongTrades)) 
            confirm_sell(1);

         exit_check(2);

     }
}
/*******************************************************************************************************************/
int start ()
 {
   if (Minute()-last_minute>=timeframe || Minute()==timeframe) 
     { 
         C=iClose(Symbol(),1,0);

spread=MathRound((Ask-Bid)/Point);

         start_process();
         last_MA=0;
         last_day=Day();
         if (AccountBalance()>max) max=AccountBalance();
     } 
if (timeframe>0) {    exit_check(1);    exit_check(2); }
    last_minute=Minute(); 

   return(0);
  }   
  
/*******************************************************************************************************************/

double ProfitMade(int index)
  {
    int i, hstTotal=HistoryTotal();
    OrderSelect(hstTotal-index,SELECT_BY_POS,MODE_HISTORY); //==false) Print("Access to history failed with error (",GetLastError(),")");
    if((OrderType()==OP_BUY || OrderType()==OP_SELL) && OrderSymbol()==Symbol() && OrderMagicNumber()==MAGIC) return(OrderProfit());
   return (0);
  }
  
/*******************************************************************************************************************/
bool ProfitStreak(int from, int to)
   {
      for (int i=from; i<=to; i++) if (ProfitMade(i)<0) return (false);
      return (true);
   }
/*******************************************************************************************************************/
int ProfitBulk(int a, int flag)
   {  double total_prof; int c;
      for (i=1; i<=a; i++) { if (ProfitMade(i)<=0) break; total_prof=total_prof+ProfitMade(i); c++; }
      if (total_prof<0) return(0);
      else if (flag==1) return (total_prof); else return (c);
   }
/*******************************************************************************************************************/
void adjust_tp()
   {  int j=1;
      if (TP_increments>0) { if (ProfitMade(1)>0) tp+=tp+TP_increments; else tp=initial_takeprofit; }//if (tp<minimum_takeprofit_allowed) tp=minimum_takeprofit_allowed; }
   }
/*******************************************************************************************************************/

double GetLots(int type)
  { double new_lots=last_lots,m,t,random_key;
if (!MM) { 
            last_lots=Lots;    
            adjust_tp();
            return(Lots);
         }
m=ProfitMade(1); 

if (target>0 && recovery_steps>0 && partitions<recovery_steps) 
   { 
    last_lots=Lots; 
    target=target-m; 
    partitions++;   
    adjust_tp();
    return(Lots);
   }

partitions=0;

if (recovery_key>0 && randomize_recovery /*&& target==0*/) 
      { 
         MathSrand(TimeLocal()); 
         start_recovery=MathRand()%recovery_key+1; /*Print ("Recovery key:",start_recovery);*/
      }

if (!randomize_recovery) start_recovery=recovery_key;

if (start_recovery<=1)
   {
    if (m==0) 
      {
         adjust_tp();
         return(last_lots);
      }
    else if (m<target)
      { 
         target=target-m; partitions=0;
         if (recovery_steps>0 && tp>0) new_lots=(Lots*(target/tp)+Lots)/recovery_steps; else if (tp>0) new_lots=(Lots*(target/tp)+Lots);
      }
    else { if (anti_martingale && target==0) new_lots=ProfitBulk(anti_martingale_level,0)*Lots+Lots; else new_lots=Lots; target=0; }

   }

else if (start_recovery>1)
   {
    if (m==0) {     adjust_tp(); return(last_lots); }
    else if (m>0 && m<target && ProfitStreak(1,start_recovery-1))
      { 
           target=target-m; partitions=0;
           if (recovery_steps>0 && tp>0) new_lots=(Lots*(target/tp)+Lots)/recovery_steps; else new_lots=(Lots*(target/tp)+Lots);
           if (new_lots>0) sl=((MaxRiskPerTrade_percentage*AccountBalance())/100)/(10*new_lots);  if (sl<minimum_stoploss) sl=minimum_stoploss; sl=MathRound(sl);
           if (sl*new_lots*10>target/2) { sl=minimum_stoploss; new_lots=target/(sl*20); }
           if (sl<minimum_stoploss) sl=minimum_stoploss;
           if (sl>maximum_stoploss) sl=maximum_stoploss;  sl=MathRound(sl);
      }
    else if (m>0 && m<target) { new_lots=Lots; target=target-m; }
    else if (m<0) { new_lots=Lots; target=target-m; }
    else { if (anti_martingale && target==0) new_lots=ProfitBulk(anti_martingale_level,0)*Lots+Lots; else new_lots=Lots; target=0; }
   }
   if ((!use_starting_balance_ratio && new_lots*10*sl>(MaxRiskPerTrade_percentage*AccountBalance())/100)
         || (use_starting_balance_ratio && new_lots*10*sl>(MaxRiskPerTrade_percentage*original_balance)/100))
          { sl=minimum_stoploss; new_lots=(((MaxRiskPerTrade_percentage*original_balance)/100)/(10*sl)); }

    if (m<0 && tp*last_lots*10<-m) { Print ("adjusting tp from ",tp," to ",target/(last_lots*10)); tp = target/(last_lots*10); }
    else tp=initial_takeprofit;
    if (tp<1) tp=initial_takeprofit;
    if (new_lots*10*sl>(MaxRiskPerTrade_percentage*original_balance)/100) { sl=minimum_stoploss; new_lots=(((MaxRiskPerTrade_percentage*original_balance)/100)/(10*sl)); }
    if (tp>sl) tp=sl;
    if (sl>(MaxRiskPerTrade_percentage*AccountBalance()/100) && sl>0) { sl=minimum_stoploss; new_lots=(MaxRiskPerTrade_percentage*AccountBalance()/100)/(sl*10); }
    if (sl<tp) sl=tp; else sl=initial_stoploss;
    
    adjust_tp();


    if (new_lots>MaxLots) new_lots=MaxLots;
    if (new_lots<Lots) new_lots=Lots;

    if ((new_lots*(Ask/Point))/10>AccountBalance()) new_lots=10*(AccountBalance()/(Ask/Point));  

    new_lots=MathRound(new_lots*10)/10;
    last_lots=new_lots;

if (m>0) { wins_count++; last_wins=last_wins+m; } else { last_wins=0; wins_count=0; }
if (last_wins==0) new_lots=Lots; else if (last_wins>=((last_lots+Lots)*10*initial_stoploss)/(1+MaxRiskPerTrade_percentage)) { last_wins=0; wins_count=0; }
if ((new_lots*(Ask/Point))/10>AccountBalance()) new_lots=10*(AccountBalance()/(Ask/Point));  new_lots=MathRound(new_lots*10)/10; last_lots=new_lots; adjust_tp();

    return (new_lots); 
  }

/*******************************************************************************************************************/

void CloseOrder(int type)
 { 
   for(int i=0;i<=OrdersTotal(); i++)  
      {
         OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
         if(OrderType()<=OP_SELL && OrderSymbol()==Symbol() && OrderComment()=="ES" && OrderMagicNumber()==MAGIC) 
            {
              if (OrderProfit()>0) successive_wins++; else  successive_wins=0;  
              if(OrderType()==OP_BUY && type==1) OrderClose(OrderTicket(),OrderLots(),Bid,3,Violet);
              else if (OrderType()==OP_SELL && type==2) OrderClose(OrderTicket(),OrderLots(),Ask,3,Violet);
            }
      }
 }    
  
/*******************************************************************************************************************/

int OpenOrders(int type)  
  {   int k,i, t, total = OrdersTotal();
      for(i=total-1;i>=0;i--)
      {
         OrderSelect(i, SELECT_BY_POS);
         t = OrderType();
         if(OrderSymbol()==Symbol() && OrderComment()=="ES" && OrderMagicNumber()==MAGIC) 
            { 
              last_profit=OrderProfit();  //last_lots=OrderLots();  
              if (t==OP_BUY && type==1) k++;
              if (t==OP_SELL && type==2) k++;
            }
      }   
   return(k);
  }
  
/*******************************************************************************************************************/

void OpenOrder(int type) 
  {int ticket; double s=0, t=0, l=Lots;

   if (type==1 && OpenOrders(1)<MaxLongTrades && OpenOrders(2)<MaxShortTrades)
     { l=GetLots(1); 
       if (sl>=15) s=SL_b[buys]; if (tp<=minimum_takeprofit_allowed) t=Ask+(minimum_takeprofit_allowed+spread)*Point; else t=TP_b[buys]; 
       ticket=OrderSend(Symbol(),OP_BUY,l,Ask,2,s,t,"ES",MAGIC,0,Green);
       last_buy_time=TimeCurrent(); last_order=1; count=0;
     }  
   else if (type==2 && OpenOrders(1)<MaxLongTrades && OpenOrders(2)<MaxShortTrades)
     { l=GetLots(2); 
       if (sl>=15) s=SL_s[sells]; if (tp<=minimum_takeprofit_allowed) t=Bid-(minimum_takeprofit_allowed+spread)*Point; else t=TP_s[sells]; 
       ticket=OrderSend(Symbol(),OP_SELL,l,Bid,2,s,t,"ES",MAGIC,0,Red);
       last_sell_time=TimeCurrent(); last_order=2;  count=0;
     }  
   if(ticket<0) Print("OrderSend error #",GetLastError()," ",type," p:",C," lots:",l," sl:",sl," tp:",tp," b_tp:",TP_b[buys]," s_tp:",TP_s[sells]," b_sl:",SL_b[buys]," s_sl:",SL_s[sells]," lots:",l);   
   else {  buy_now=false; sell_now=false; }
  }
  
/*******************************************************************************************************************/

